-- D:\PROJEKTE\VIRTEX2PRO_BOARD\FPGA_CONFIG
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Thu Mar 18 15:48:59 2004
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY top_level IS
END top_level;

ARCHITECTURE testbench_arch OF top_level IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT top_level
		PORT (
			A : InOut  std_logic_vector (24 DOWNTO 0);
			WE_n : Out  std_logic;
			CE_n : Out  std_logic;
			OE_n : Out  std_logic;
			READY : In  std_logic;
			CS_B : InOut  std_logic;
			CCLK : InOut  std_logic;
			RDWR_B : Out  std_logic;
			PROG_B : Out  std_logic;
			INIT_B : In  std_logic;
			DONE : In  std_logic;
			BUSY : In  std_logic;
			DIP : In  std_logic_vector (2 DOWNTO 0);
			RST_n : In  std_logic;
			CLK : In  std_logic
		);
	END COMPONENT;

	SIGNAL A : std_logic_vector (24 DOWNTO 0);
	SIGNAL WE_n : std_logic;
	SIGNAL CE_n : std_logic;
	SIGNAL OE_n : std_logic;
	SIGNAL READY : std_logic;
	SIGNAL CS_B : std_logic;
	SIGNAL CCLK : std_logic;
	SIGNAL RDWR_B : std_logic;
	SIGNAL PROG_B : std_logic;
	SIGNAL INIT_B : std_logic;
	SIGNAL DONE : std_logic;
	SIGNAL BUSY : std_logic;
	SIGNAL DIP : std_logic_vector (2 DOWNTO 0);
	SIGNAL RST_n : std_logic;
	SIGNAL CLK : std_logic;

BEGIN
	UUT : top_level
	PORT MAP (
		A => A,
		WE_n => WE_n,
		CE_n => CE_n,
		OE_n => OE_n,
		READY => READY,
		CS_B => CS_B,
		CCLK => CCLK,
		RDWR_B => RDWR_B,
		PROG_B => PROG_B,
		INIT_B => INIT_B,
		DONE => DONE,
		BUSY => BUSY,
		DIP => DIP,
		RST_n => RST_n,
		CLK => CLK
	);

	PROCESS -- clock process for CLK,
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 20 ns;
		CLK <= transport '1';
		WAIT FOR 20 ns;
		WAIT FOR 80 ns;
		CLK <= transport '0';
		WAIT FOR 80 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for CLK
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_WE_n(
			next_WE_n : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (WE_n /= next_WE_n) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns WE_n="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, WE_n);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_WE_n);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_CE_n(
			next_CE_n : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CE_n /= next_CE_n) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns CE_n="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, CE_n);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_CE_n);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_OE_n(
			next_OE_n : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (OE_n /= next_OE_n) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns OE_n="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, OE_n);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_OE_n);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_RDWR_B(
			next_RDWR_B : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (RDWR_B /= next_RDWR_B) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns RDWR_B="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, RDWR_B);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_RDWR_B);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_PROG_B(
			next_PROG_B : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (PROG_B /= next_PROG_B) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns PROG_B="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, PROG_B);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_PROG_B);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_A(
			next_A : std_logic_vector (24 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (A /= next_A) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns A="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, A);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_A);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_CS_B(
			next_CS_B : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CS_B /= next_CS_B) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns CS_B="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, CS_B);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_CS_B);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_CCLK(
			next_CCLK : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CCLK /= next_CCLK) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns CCLK="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, CCLK);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_CCLK);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		READY <= transport '0';
		INIT_B <= transport '1';
		DONE <= transport '0';
		BUSY <= transport '1';
		DIP <= transport std_logic_vector'("000"); --0
		RST_n <= transport '0';
		-- --------------------
		WAIT FOR 400 ns; -- Time=400 ns
		RST_n <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=600 ns
		RST_n <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=800 ns
		INIT_B <= transport '0';
		-- --------------------
		WAIT FOR 1000 ns; -- Time=1800 ns
		RST_n <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=2000 ns
		READY <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=2200 ns
		INIT_B <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=2400 ns
		BUSY <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=2600 ns
		BUSY <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=2800 ns
		INIT_B <= transport '1';
		-- --------------------
		WAIT FOR 220 ns; -- Time=3020 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION top_level_cfg OF top_level IS
	FOR testbench_arch
	END FOR;
END top_level_cfg;
